-- EasyRaid 2.6.0
-- Automatically display raid subgroups and classes
-- Created by Soin (EU-Vol'jin) on January 13, 2006

ER_isLoaded = false;

ER_UPDATE_INTERVAL = 3;
ER_timeSinceLastUpdate = 0;

ER_UPDATE_PVP_FLAG_INTERVAL = 3;
ER_timeSinceLastUpdatePVPFlag = 0;

ER_UPDATE_RAID_TARGET_ICON_INTERVAL = 0.5;
ER_timeSinceLastUpdateRaidTargetIcon = 0;

ER_UPDATE_AFK_INTERVAL = 3;
ER_timeSinceLastUpdateAFK = 0;

ER_RANGE_CHECK_INTERVAL = 1;
ER_timeSinceLastRangeCheck = 0;

ER_UPDATE_TARGETS_INTERVAL = 1;
ER_timeSinceLastUpdateTargets = 0;

ER_UPDATE_MISC = 0.5;
ER_timeSinceLastUpdateMisc = 0;

ER_showAllGroups = false;
ER_raidIsShown = true;

ER_numRaidGroups = 0;

ER_commonBuffs = {
	["Spell_Holy_WordFortitude"] = true, -- Power Word: Fortitude
	["Spell_Holy_PrayerOfFortitude"] = true, -- Prayer of Fortitude
	["Spell_Holy_MagicalSentry"] = true, -- Arcane Intellect
	["Spell_Holy_ArcaneIntellect"] = true, -- Arcane Brilliance
	["Spell_Nature_Regeneration"] = true, -- Mark of the Wild and Gift of the Wild
	["Spell_Holy_DivineSpirit"] = true, -- Divine Spirit
	["Spell_Holy_PrayerofSpirit"] = true, -- Prayer of Spirit
	["Spell_Shadow_AntiShadow"] = true, -- Shadow Protection
	["Spell_Holy_PrayerofShadowProtection"] = true, -- Prayer of Shadow Protection
	["Spell_Magic_MageArmor"] = true, -- Blessing of Kings
	["Spell_Magic_GreaterBlessingofKings"] = true, -- Greater Blessing of Kings
	["Spell_Holy_PrayerOfHealing02 "] = true,-- Blessing of Light
	["Spell_Holy_GreaterBlessingofLight"] = true, -- Greater Blessing of Light
	["Spell_Holy_FistOfJustice"] = true, -- Blessing of Might
	["Spell_Holy_GreaterBlessingofKings"] = true, -- Greater Blessing of Might
	["Spell_Holy_SealOfSalvation"] = true, -- Blessing of Salvation
	["Spell_Holy_GreaterBlessingofSalvation"] = true, -- Greater Blessing of Salvation
	["Spell_Nature_LightningShield"] = true, -- Blessing of Sanctuary
	["Spell_Holy_GreaterBlessingofSanctuary"] = true, -- Greater Blessing of Sanctuary
	["Spell_Holy_SealOfWisdom"] = true, -- Blessing of Wisdom
	["Spell_Holy_GreaterBlessingofWisdom"] = true -- Greater Blessing of Wisdom
};

function ER_OnLoad()
	if ( not ER_Config ) then
		ER_InitConfig();
	end
	
	ER_UpdateConfig();
		
	ER_ContainerFrame_LoadLocation();

--	if ( not FriendsFrame:IsUserPlaced() ) then
--		FriendsFrame:SetPoint("TOPLEFT", "UIParent", "CENTER", -FriendsFrame:GetWidth()/2, FriendsFrame:GetHeight()/2);
--	end
--	UIPanelWindows["FriendsFrame"] = nil;
--	tinsert(UISpecialFrames,"FriendsFrame");

	RaidFrame:SetScript("OnShow", ER_RaidFrame_OnShow)
	RaidFrame:SetScript("OnHide", ER_RaidFrame_OnHide)

	if ( RAID_SUBGROUP_LISTS ) then
		ER_Load();
	else
		hooksecurefunc("RaidFrame_LoadUI", ER_RaidFrame_LoadUI);
	end
	
	if ( ER_RaidAssistHasMTSupport() ) then
		ER_MainTanksOnLoad();
		ER_TargetsOnLoad();
	end
end

function ER_RaidFrame_LoadUI()
	if ( not ER_isLoaded ) then
		ER_Load();
	end
end

function ER_Load()
	ER_isLoaded = true;

	--ER_SavedRaidGroupFrame_OnUpdate = RaidGroupFrame_OnUpdate;
	--RaidGroupFrame_OnUpdate = ER_RaidGroupFrame_OnUpdate;
	--RaidFrame:SetScript("OnUpdate", RaidGroupFrame_OnUpdate);

	hooksecurefunc("RaidGroupButton_OnDragStart", ER_RaidGroupButton_OnDragStart);
	hooksecurefunc("RaidGroupButton_OnDragStop", ER_RaidGroupButton_OnDragStop);

	hooksecurefunc("RaidGroupFrame_OnHide", ER_RaidFrame_OnHide);
	RaidFrame:SetScript("OnHide", RaidGroupFrame_OnHide)
	
	hooksecurefunc("RaidGroupFrame_Update", ER_RaidGroupFrame_Update);
end

function ER_OnRaidRosterUpdate()
	ER_RaidGroups_Update();
	ER_UpdateMainTanks();
	ER_PlayerTargetChanged();
end

function ER_OnUpdateWorldStates()
	ER_timeSinceLastUpdatePVPFlag = max(ER_UPDATE_PVP_FLAG_INTERVAL - 0.5, ER_timeSinceLastUpdatePVPFlag);
end

function ER_OnRaidTargetUpdate()
	ER_timeSinceLastUpdateRaidTargetIcon = max(ER_UPDATE_RAID_TARGET_ICON_INTERVAL - 0.5, ER_timeSinceLastUpdateRaidTargetIcon);
end

function ER_OnChatMsgAddon(prefix, message, destination, sender)
	-- ER_Debug(prefix.." | "..message.." | "..destination.." | "..sender);
end

function ER_OnUpdate(elapsed)
	if ( ER_isLoaded ) then
	
		if ( not UIParent:IsShown() ) then
			return;
		end
	
		ER_timeSinceLastUpdate = ER_timeSinceLastUpdate + elapsed;
		if ( ER_timeSinceLastUpdate >= ER_UPDATE_INTERVAL ) then
			ER_timeSinceLastUpdate = 0;
			ER_RaidGroups_Update();
		end

		ER_timeSinceLastUpdatePVPFlag = ER_timeSinceLastUpdatePVPFlag + elapsed;
		if ( ER_timeSinceLastUpdatePVPFlag >= ER_UPDATE_PVP_FLAG_INTERVAL ) then
			ER_timeSinceLastUpdatePVPFlag = 0;
			ER_RaidGroups_UpdatePVPFlag();
		end

		ER_timeSinceLastUpdateRaidTargetIcon = ER_timeSinceLastUpdateRaidTargetIcon + elapsed;
		if ( ER_timeSinceLastUpdateRaidTargetIcon >= ER_UPDATE_RAID_TARGET_ICON_INTERVAL ) then
			ER_timeSinceLastUpdateRaidTargetIcon = 0;
			ER_RaidGroups_UpdateRaidTargetIcon();
		end

		ER_timeSinceLastUpdateAFK = ER_timeSinceLastUpdateAFK + elapsed;
		if ( ER_timeSinceLastUpdateAFK >= ER_UPDATE_AFK_INTERVAL ) then
			ER_timeSinceLastUpdateAFK = 0;
			ER_RaidGroups_UpdateAFK();
		end

		ER_timeSinceLastRangeCheck = ER_timeSinceLastRangeCheck + elapsed;
		if ( ER_timeSinceLastRangeCheck >= ER_RANGE_CHECK_INTERVAL ) then
			ER_timeSinceLastRangeCheck = 0;
			ER_RaidGroups_UpdateRangeCheck();
		end

		ER_timeSinceLastUpdateTargets = ER_timeSinceLastUpdateTargets + elapsed;
		if ( ER_timeSinceLastUpdateTargets >= ER_UPDATE_TARGETS_INTERVAL ) then
			ER_timeSinceLastUpdateTargets = 0;
			ER_RaidGroup_UpdateTargets();
		end

		ER_timeSinceLastUpdateMisc = ER_timeSinceLastUpdateMisc + elapsed;
		if ( ER_timeSinceLastUpdateMisc >= ER_UPDATE_MISC ) then
			ER_timeSinceLastUpdateMisc = 0;
			ER_RaidGroups_UpdateMisc();
		end

		if ( ER_RaidAssistHasMTSupport() ) then
			ER_MainTanksOnUpdate(elapsed);
			ER_TargetsOnUpdate(elapsed);
		end
	end
end

function EB_PlayerEnterInCombat()
	ER_showAllGroups = false;
	ER_raidIsShown = true;

	ER_RaidGroups_UpdateBuffs();
	ER_RaidGroups_Update();

	if ( ER_OptionsSideFrame:IsShown() ) then
		ER_OptionsSideFrame:Hide();
	end
end

function EB_PlayerLeaveCombat()
	ER_RaidGroups_UpdateBuffs();
	ER_RaidGroups_Update();
end

-----------------------------------------------------------------------

function ER_RaidGroups_Update()
	if ( not ER_isLoaded ) then
		return;
	end

	if ( not UIParent:IsShown() ) then
		return;
	end

	if ( ER_TargetsFrameIsMovingOrSizing ) then
		return;
	end
	
	if ( InCombatLockdown() ) then
		return;
	end

	-- Hide party frames
	RaidOptionsFrame_UpdatePartyFrames();

	-- Clear hidden frames
	for i=1, ER_numRaidGroups do
		local frame = getglobal("ER_RaidGroup"..i);
		if ( frame.filterID and not frame:IsShown() ) then
			frame.filterID = nil;
		end
	end

	local i;
	local playerGroupNumber;

	-- Find player group number
	for i=1, GetNumRaidMembers() do
		local name, _, subgroup = GetRaidRosterInfo(i);
		if ( name == UnitName("player") ) then
			playerGroupNumber = subgroup;
			break;
		end
	end

	ER_raidGroupSerialNumber = (ER_raidGroupSerialNumber or 1) + 1;
	
	if ( playerGroupNumber ) then
		ER_previousRaidGroupNameX = nil;
		ER_previousRaidGroupNameY = nil;
		ER_raidGroupBuffsWidth = 0;
		ER_firstRaidGroup = nil;
		ER_raidGroupMaxX = nil;
		ER_raidGroupMinY = nil;
		ER_raidGroupTargets = nil;
		
		-- Show player group
		if ( ER_Config.playerGroupIsShown and (not ER_showAllGroups or not ER_raidIsShown) ) then
			ER_RaidGroup_GenerateFrame(playerGroupNumber);
		end

		-- Show targets
		if ( ER_Config.targetsAreShown ) then
			ER_raidGroupTargets = ER_RaidGroup_GenerateFrame("TARGETS");		
		end
	
		-- Show main tanks
		if ( ER_Config.mainTanksAreShown and ER_mainTanks and ((not ER_showAllGroups or not ER_raidIsShown)
				or not(ER_Config.mainTanksAreAttached and ER_Config.mainTanksAttachment == "RAID")) ) then
			ER_RaidGroup_GenerateFrame("MAINTANKS");
		end
		
		-- Show groups
		for i=1, getn(ER_Config.groups) do
			local group = ER_Config.groups[i];
			if ( (group.isShown or ER_showAllGroups) and ER_raidIsShown ) then
				if ( not (ER_Config.playerGroupIsShown and group.number == playerGroupNumber) or ER_showAllGroups ) then
					ER_RaidGroup_GenerateFrame(group.number);
				end
			end
		end
		
		-- Show classes
		for i=1, getn(ER_Config.classes) do
			local class = ER_Config.classes[i];
			if ( class.isShown and not ER_showAllGroups and ER_raidIsShown ) then
				ER_RaidGroup_GenerateFrame(class.name);
			end
		end
		
		if ( ER_firstRaidGroup ) then
			local alignment = ER_GetSmartAlignment(ER_ContainerFrame, ER_Config["alignment"]);		
			if ( alignment == "TOPRIGHT" ) then
				ER_firstRaidGroup:SetPoint("TOPLEFT", "ER_ContainerFrame", "TOPLEFT", 4 + (ER_ContainerFrame:GetRight()/(ER_Config.scale/100) - ER_raidGroupMaxX) - 4, -4+ER_raidGroupOffsetY);
			elseif ( alignment == "BOTTOMLEFT" ) then
				ER_firstRaidGroup:SetPoint("TOPLEFT", "ER_ContainerFrame", "TOPLEFT", 4, -4 + ER_raidGroupOffsetY + (ER_ContainerFrame:GetBottom()/(ER_Config.scale/100) - ER_raidGroupMinY) + 4);
			elseif ( alignment == "BOTTOMRIGHT" ) then
				ER_firstRaidGroup:SetPoint("TOPLEFT", "ER_ContainerFrame", "TOPLEFT", 4 + (ER_ContainerFrame:GetRight()/(ER_Config.scale/100) - ER_raidGroupMaxX) - 4, -4 + ER_raidGroupOffsetY + (ER_ContainerFrame:GetBottom()/(ER_Config.scale/100) - ER_raidGroupMinY) + 4);
			end
		end
	end
	
	-- Clear non updated frames
	for i=1, ER_numRaidGroups do
		local frame = getglobal("ER_RaidGroup"..i);
		if ( frame:IsShown() and frame.serialNumber ~= ER_raidGroupSerialNumber ) then
			frame:SetAttribute("nameList", nil);
			frame.numMembers = 0;
			frame:Hide();
			frame.filterID = nil;
		end
	end

	if ( ER_ContainerFrameIsMovingOrSizing ) then
		ER_RaidGroups_DelayedUpdate();
	end
end


function ER_RaidGroups_DelayedUpdate()
	ER_timeSinceLastUpdate = max(ER_UPDATE_INTERVAL - 0.2, ER_timeSinceLastUpdate);
end

-----------------------------------------------------------------------

function ER_RaidGroups_UpdateTitle()
	if ( ER_isLoaded ) then
		local i;
	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			
			if ( not ER_Config.titleOfTheFramesIsShown ) then
				getglobal(frame:GetName().."Name"):Hide();
			else
				getglobal(frame:GetName().."Name"):Show();
			end
		end
	
		if ( not ER_Config.titleOfTheFramesIsShown ) then
			ER_raidGroupOffsetY = 0;
		else
			ER_raidGroupOffsetY = -12;
		end
	end
end

function ER_RaidGroups_UpdateName()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateName(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_UpdateBuffs()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateBuffs(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_UpdateBackground()
	if ( ER_isLoaded ) then
		local i;
	
		for i=1, ER_numRaidGroups do
			local background = getglobal("ER_RaidGroup"..i.."MenuBackdrop");
			if ( ER_Config.backgroundIsShown ) then
				background:Show();
			else
				background:Hide();
			end
		end
	end
end

function ER_RaidGroups_UpdateRangeCheck()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateRangeCheck(button);
					end
				end
			end
		end
		
		ER_UnitButtonDropDown_UpdateRangeCheck();
	end
end

function ER_RaidGroups_UpdatePVPFlag()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdatePVPFlag(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_UpdateRaidTargetIcon()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateRaidTargetIcon(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_UpdateAFK()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateAFK(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_UpdateMisc()
	if ( ER_isLoaded ) then
		local i, j;	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			if ( frame:IsShown() ) then
				for j=1, frame.numMembers do
					local button = getglobal("ER_RaidGroup"..i.."UnitButton"..j);
					if ( button and button:IsShown() ) then
						ER_UnitButton_UpdateMisc(button);
					end
				end
			end
		end
	end
end

function ER_RaidGroups_Refresh()
	if ( ER_isLoaded ) then
		local i;
	
		for i=1, ER_numRaidGroups do
			local frame = getglobal("ER_RaidGroup"..i);
			
			if ( frame:IsShown() ) then
				frame:Hide();
			end
		end
		
		ER_RaidGroups_Update();
		ER_PlayerTargetChanged();
	end
end

-----------------------------------------------------------------------

function ER_GetSmartAlignment(frame, alignment)
	if ( alignment == "SMART" ) then
		local screenX, screenY = UIParent:GetCenter();
		screenX = screenX * UIParent:GetEffectiveScale();
		screenY = screenY - 50;
		screenY = screenY * UIParent:GetEffectiveScale();		
		local frameX, frameY = frame:GetCenter();
		frameX = frameX * frame:GetEffectiveScale();
		frameY = frameY * frame:GetEffectiveScale();
		
		local alignmentX, alignmentY;
		
		if ( frameX < screenX ) then
			alignmentX = "LEFT";
		else
			alignmentX = "RIGHT";
		end
		
		if ( frameY > screenY ) then
			alignmentY = "TOP";
		else
			alignmentY = "BOTTOM";
		end
		
		alignment = alignmentY..alignmentX;
	end
	
	return alignment;
end

function ER_SetAnchorPoint(frame, alignment)
	alignment = ER_GetSmartAlignment(frame, alignment)

	local point, relativeObject, relativePoint, x, y = frame:GetPoint(1);
	if ( point and point ~= alignment ) then
		local width, height = frame:GetWidth(), frame:GetHeight();
		local left, top, right, bottom;
		if ( point == "TOPLEFT" ) then
			left = x;
			top = y;
			right = x + width;
			bottom = y - height;
		elseif ( point == "TOPRIGHT" ) then
			left = x - width;
			top = y;
			right = x;
			bottom = y - height;
		elseif ( point == "BOTTOMLEFT" ) then
			left = x;
			top = y + height;
			right = x + width;
			bottom = y;
		elseif ( point == "BOTTOMRIGHT" ) then
			left = x - width;
			top = y + height;
			right = x;
			bottom = y;
		end

		local newX, newY;
		if ( alignment == "TOPLEFT" ) then
			newX, newY = left, top;
		elseif ( alignment == "TOPRIGHT" ) then
			newX, newY = right, top;
		elseif ( alignment == "BOTTOMLEFT" ) then
			newX, newY = left, bottom;
		elseif ( alignment == "BOTTOMRIGHT" ) then
			newX, newY = right, bottom;
		end
		
		frame:ClearAllPoints();
		frame:SetPoint(alignment, UIParent, "TOPLEFT", newX, newY);
	end
end

-----------------------------------------------------------------------

function ER_UpdateSpells()
	local _, class = UnitClass("player");
	if ( not (class == "PRIEST" or class == "DRUID" or class == "PALADIN" or class == "SHAMAN") ) then
		return;
	end

	local i = 1;
	local spellName;
	local spells = { };

	repeat
		spellName = GetSpellName(i, BOOKTYPE_SPELL);
		if ( spellName ) then
			if ( SpellHasRange(spellName) and IsSpellInRange(spellName, "player") == 1 ) then
				if ( not spells[spellName] ) then
					if ( ER_friendlySpells and ER_friendlySpells[spellName] ~= nil ) then
						spells[spellName] = ER_friendlySpells[spellName];
					else
						spells[spellName] = 0;
					end
				end
			end
			i = i + 1;
		end
	until not spellName;
	
	ER_friendlySpells = spells;
	
	if ( ER_Config.mostUsedFriendlySpell ) then
		if ( ER_friendlySpells[ER_Config.mostUsedFriendlySpell] and ER_friendlySpells[ER_Config.mostUsedFriendlySpell] == 0 ) then
			ER_friendlySpells[ER_Config.mostUsedFriendlySpell] = 15;
		end
	end
end

function ER_OnUnitSpellCastSent(spellName)
	if ( ER_friendlySpells and ER_friendlySpells[spellName] ) then
		ER_friendlySpells[spellName] = ER_friendlySpells[spellName] + 1;
		
		if ( time() - (ER_lastMostUsedSpellSearch or 0) >= 15 ) then
			local spellName, count;
			local maxCount = 0;
			for spellName, count in pairs(ER_friendlySpells) do
				if ( count > maxCount ) then
					ER_Config.mostUsedFriendlySpell = spellName;
					maxCount = count;
				end
			end
			ER_lastMostUsedSpellSearch = time();
		end
	end
end

function ER_UnitIsInRange(unit)
	if ( not UnitIsVisible(unit) ) then
		return false;
	end
	
	if ( not UnitIsFriend(unit, "player") ) then
		return true;
	end

	if ( SpellIsTargeting() ) then
 		if ( not SpellCanTargetUnit(unit)  ) then
 			return false;
		end
	else
		if ( UnitIsDead(unit) ) then
			if ( not CheckInteractDistance(unit, 4) ) then
				return false;
			end
		else
			if ( ER_Config.mostUsedFriendlySpell and IsSpellInRange(ER_Config.mostUsedFriendlySpell, unit) ~= 1 ) then
				return false;
			end
		end
	end
		
	return true;
end

-----------------------------------------------------------------------

function ER_GetRaidUnitByName(name)
	local i;
	for i = 1, GetNumRaidMembers() do
		local unit = "raid"..i;
		if (UnitName(unit) == name) then
			return unit, i;
		end
	end
end

-----------------------------------------------------------------------

function ER_PairsByKeys(t)
	local a = {};
	local n;
	for n in pairs(t) do table.insert(a, n) end;
	table.sort(a);
	local i = 0;      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1;
		if ( a[i] == nil ) then
			return nil;
		else
			return a[i], t[a[i]];
		end
	end
	return iter;
end

function ER_FormatTime(seconds)
	return format("%02d:%02d", seconds/60, mod(seconds, 60));
end

function ER_Debug(message)
	DEFAULT_CHAT_FRAME:AddMessage(message, 0, 1, 0);
end

function ER_Dump(expression)
	SlashCmdList["DEVTOOLSDUMP"](expression);
end